from pycparser.c_lexer import CLexer


def token_list(clex):
    return list(iter(clex.token, None))


def token_types(clex):
    return [i.type for i in token_list(clex)]

class C_lexer():
    """ Test lexing of strings that are not supposed to cause
        errors. Therefore, the error_func passed to the lexer
        raises an exception.
    """
    def error_func(self, msg, line, column):
        self.fail(msg)

    def type_lookup_func(self, typ):
        if typ.startswith('mytype'):
            return True
        else:
            return False

    def setUp(self):
        self.clex = CLexer(self.error_func, lambda: None, lambda: None,
                           self.type_lookup_func)
        self.clex.build(optimize=False)

    def get_tokens(self, str):
        self.clex.input(str)
        return token_types(self.clex)

mylex = C_lexer()
mylex.setUp()

# t=mylex.get_tokens('( a && b ) || c ? d : e')
t=mylex.get_tokens('len + ( int ) STRLEN ( buf ) + 3 > MAXPATHL')

print(t)

for i in t:
   print(i)

