#
# if-cond.R, 13 May 24

library("colorspace")
library("plyr")


par(bty="l")
par(las=1)
par(pch="+")
pal_col=rainbow(4)


count_toks=function(df)
{
e_toks=unlist(strsplit(df$expr, " "))
df$num_toks=length(e_toks)
df$num_arith=sum(e_toks %in% c("+", "-", "*", "/"))
df$num_bitwise=sum(e_toks %in% c("&", "|", "^"))
df$num_relational=sum(e_toks %in% c("<", "<=", ">", ">="))
df$num_logical=sum(e_toks %in% c("&&", "||"))
df$num_equal=sum(e_toks %in% c("==", "!="))

return(df)
}


nest_level=function(df)
{
if(nrow(df) < 2)
   {
   df$nesting=1
   return(df)
   }

df=df[order(df$if_line, decreasing=FALSE), ]
df$nesting=NA

n_stack=rep(0, 100)
n_stack[1]=1e30

nesting=1
for (ifs in 1:nrow(df))
   {
   while (df$if_line[ifs] >  n_stack[nesting])
      nesting=nesting-1
   df$nesting[ifs]=nesting
   nesting=nesting+1
   n_stack[nesting]=df$cmpd_end[ifs]
   }

return(df)
}


# Both "a string" and '"' can appear in C source
vim=read.csv("vim.csv", as.is=TRUE, sep=";", quote="", flush=TRUE)

v_expr=adply(vim,  .mar=1, count_toks)

v_nest=ddply(v_expr, .(file), nest_level)

plot(count(vim$if_col), log="y",
	xlim=c(1, 100))

plot(vim$if_col, nchar(vim$expr),
	ylim=c(1, 500))

plot(count(v_expr$num_toks), log="y",
	xlim=c(1, 100))

plot(v_expr$if_col, v_expr$num_toks,
	xlim=c(1, 100))

clause_nest=ddply(v_nest, .(nesting), function(df) mean(1+df$num_logical))

plot(clause_nest,
	xlab="Nesting", ylab="clauses")

token_nest=ddply(v_nest, .(nesting), function(df) mean(df$num_tok))

plot(token_nest,
	xlab="Nesting", ylab="clauses")

